Page MenuHomePhabricator

Error on 'Mark as Sent' page for automatic-send partners
Closed, ResolvedPublic

Description

Task

The Library Card platform distributes access to a range of publisher partners. In doing so, we directly support 5 different kinds of access methods. For the 'Email' and 'Access codes' methods, coordinators need to access a 'Mark as Sent' page to confirm that the application has been successfully processed. For all other methods, we mark applications as sent automatically (Link, Proxy, Bundle - see T206627). For these partners, coordinators should have no need to access the Mark as Sent page, and indeed nothing should link them there. As such, if a coordinator navigates to a partner's Send page we should provide them with a sensible error code, and don't need to provide any specialised (translated) text there.

This view is defined in SendReadyApplicationsView, and fills out send_partner.html.

The steps to completing this task should be:

  • Remove the condition which displays an error message on send_partner.html for non-Email or Codes partners. (send_partner.html#L188 and the following line).
  • Override DetailView's dispatch function by adding a new function called dispatch() which checks if the current partner has an authorization_method of Partner.EMAIL or Partner.CODES.
    • If it does, return super(SendReadyApplicationsView, self).dispatch(request, *args, **kwargs).
    • If not, raise Http404 (see an example here) with a helpful error message.
  • Add two new tests to applications/tests.py in the MarkSentCase class. One should test that an 'Email' method partner send page is viewable, and the other should confirm that a 'Proxy' method partner send page returns a 404.

Good first bug

This task has been placed in the good first task category. This means it has been scoped and written in a way that makes it simpler for folks who haven’t contributed to the tool’s development or open source software in the past.

If that’s you, welcome! Please feel free to ask questions here about this specific task or the codebase more generally. We’ll be more than happy to help you and clarify the steps needed to complete the task, whether that’s setting up the repository, implementing the necessary changes, or pushing your changes to Github.

If you have experience contributing to this project or similar ones, please consider leaving this one for someone new, and taking a look at the Open Tasks column of the workboard for another task. Also feel free to help out if you see unanswered questions here!

How to contribute

Assign yourself to this task: Click the ‘Add Action’ dropdown menu below and then select Assign / Claim. The box should fill your username in automatically, then click Submit!

To submit your changes, you should fork the repository and create a new branch. After pushing your changes to your Github branch, you can open a pull request. Please link your pull request in a comment here when it has been submitted. Experienced contributors to the project will review your code and either provide feedback or merge it in!

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 3 2019, 4:54 PM
Samwalton9 triaged this task as Low priority.Oct 3 2019, 4:54 PM
Samwalton9 added a project: good first task.
Samwalton9 renamed this task from Error on mark as sent page for automatic-send partners to Error on 'Mark as Sent' page for automatic-send partners.Oct 23 2019, 4:31 PM
Samwalton9 updated the task description. (Show Details)
Restricted Application added a subscriber: Sadads. · View Herald TranscriptOct 23 2019, 4:31 PM
lalit97 claimed this task.Jan 31 2020, 8:10 PM
This comment was removed by lalit97.

Hello @Samwalton9 I have completed the project setup, will raise a pull request soon.

Samwalton9 closed this task as Resolved.Feb 14 2020, 4:09 PM
Samwalton9 moved this task from Doing to Done on the Library-Card-Platform board.